/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type Option, type OptionOrNullable, type ReadonlyAccount, type ReadonlySignerAccount, type ReadonlyUint8Array, type TransactionSigner, type WritableAccount, type WritableSignerAccount } from '@solana/web3.js';
import { type TokenStandardArgs } from '@tensor-foundation/resolvers';
import { TENSOR_MARKETPLACE_PROGRAM_ADDRESS } from '../programs';
import { type AuthorizationDataLocal, type AuthorizationDataLocalArgs } from '../types';
export type BuyLegacyInstruction<TProgram extends string = typeof TENSOR_MARKETPLACE_PROGRAM_ADDRESS, TAccountFeeVault extends string | IAccountMeta<string> = string, TAccountBuyer extends string | IAccountMeta<string> = string, TAccountBuyerTa extends string | IAccountMeta<string> = string, TAccountListTa extends string | IAccountMeta<string> = string, TAccountListState extends string | IAccountMeta<string> = string, TAccountMint extends string | IAccountMeta<string> = string, TAccountOwner extends string | IAccountMeta<string> = string, TAccountPayer extends string | IAccountMeta<string> = string, TAccountTakerBroker extends string | IAccountMeta<string> = string, TAccountMakerBroker extends string | IAccountMeta<string> = string, TAccountRentDestination extends string | IAccountMeta<string> = string, TAccountTokenProgram extends string | IAccountMeta<string> = 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA', TAccountAssociatedTokenProgram extends string | IAccountMeta<string> = 'ATokenGPvbdGVxr1b2hvZbsiqW5xWH25efTNsLJA8knL', TAccountMarketplaceProgram extends string | IAccountMeta<string> = 'TCMPhJdwDryooaGtiocG1u3xcYbRpiJzb283XfCZsDp', TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TAccountMetadata extends string | IAccountMeta<string> = string, TAccountEdition extends string | IAccountMeta<string> = string, TAccountBuyerTokenRecord extends string | IAccountMeta<string> = string, TAccountListTokenRecord extends string | IAccountMeta<string> = string, TAccountAuthorizationRules extends string | IAccountMeta<string> = string, TAccountAuthorizationRulesProgram extends string | IAccountMeta<string> = string, TAccountTokenMetadataProgram extends string | IAccountMeta<string> = string, TAccountSysvarInstructions extends string | IAccountMeta<string> = string, TAccountCosigner extends string | IAccountMeta<string> = 'TCMPhJdwDryooaGtiocG1u3xcYbRpiJzb283XfCZsDp', TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountFeeVault extends string ? WritableAccount<TAccountFeeVault> : TAccountFeeVault,
    TAccountBuyer extends string ? ReadonlyAccount<TAccountBuyer> : TAccountBuyer,
    TAccountBuyerTa extends string ? WritableAccount<TAccountBuyerTa> : TAccountBuyerTa,
    TAccountListTa extends string ? WritableAccount<TAccountListTa> : TAccountListTa,
    TAccountListState extends string ? WritableAccount<TAccountListState> : TAccountListState,
    TAccountMint extends string ? ReadonlyAccount<TAccountMint> : TAccountMint,
    TAccountOwner extends string ? WritableAccount<TAccountOwner> : TAccountOwner,
    TAccountPayer extends string ? WritableSignerAccount<TAccountPayer> & IAccountSignerMeta<TAccountPayer> : TAccountPayer,
    TAccountTakerBroker extends string ? WritableAccount<TAccountTakerBroker> : TAccountTakerBroker,
    TAccountMakerBroker extends string ? WritableAccount<TAccountMakerBroker> : TAccountMakerBroker,
    TAccountRentDestination extends string ? WritableAccount<TAccountRentDestination> : TAccountRentDestination,
    TAccountTokenProgram extends string ? ReadonlyAccount<TAccountTokenProgram> : TAccountTokenProgram,
    TAccountAssociatedTokenProgram extends string ? ReadonlyAccount<TAccountAssociatedTokenProgram> : TAccountAssociatedTokenProgram,
    TAccountMarketplaceProgram extends string ? ReadonlyAccount<TAccountMarketplaceProgram> : TAccountMarketplaceProgram,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    TAccountMetadata extends string ? WritableAccount<TAccountMetadata> : TAccountMetadata,
    TAccountEdition extends string ? ReadonlyAccount<TAccountEdition> : TAccountEdition,
    TAccountBuyerTokenRecord extends string ? WritableAccount<TAccountBuyerTokenRecord> : TAccountBuyerTokenRecord,
    TAccountListTokenRecord extends string ? WritableAccount<TAccountListTokenRecord> : TAccountListTokenRecord,
    TAccountAuthorizationRules extends string ? ReadonlyAccount<TAccountAuthorizationRules> : TAccountAuthorizationRules,
    TAccountAuthorizationRulesProgram extends string ? ReadonlyAccount<TAccountAuthorizationRulesProgram> : TAccountAuthorizationRulesProgram,
    TAccountTokenMetadataProgram extends string ? ReadonlyAccount<TAccountTokenMetadataProgram> : TAccountTokenMetadataProgram,
    TAccountSysvarInstructions extends string ? ReadonlyAccount<TAccountSysvarInstructions> : TAccountSysvarInstructions,
    TAccountCosigner extends string ? ReadonlySignerAccount<TAccountCosigner> & IAccountSignerMeta<TAccountCosigner> : TAccountCosigner,
    ...TRemainingAccounts
]>;
export type BuyLegacyInstructionData = {
    discriminator: ReadonlyUint8Array;
    maxAmount: bigint;
    optionalRoyaltyPct: Option<number>;
    authorizationData: Option<AuthorizationDataLocal>;
};
export type BuyLegacyInstructionDataArgs = {
    maxAmount: number | bigint;
    optionalRoyaltyPct?: OptionOrNullable<number>;
    authorizationData?: OptionOrNullable<AuthorizationDataLocalArgs>;
};
export declare function getBuyLegacyInstructionDataEncoder(): Encoder<BuyLegacyInstructionDataArgs>;
export declare function getBuyLegacyInstructionDataDecoder(): Decoder<BuyLegacyInstructionData>;
export declare function getBuyLegacyInstructionDataCodec(): Codec<BuyLegacyInstructionDataArgs, BuyLegacyInstructionData>;
export type BuyLegacyInstructionExtraArgs = {
    tokenStandard?: TokenStandardArgs;
};
export type BuyLegacyAsyncInput<TAccountFeeVault extends string = string, TAccountBuyer extends string = string, TAccountBuyerTa extends string = string, TAccountListTa extends string = string, TAccountListState extends string = string, TAccountMint extends string = string, TAccountOwner extends string = string, TAccountPayer extends string = string, TAccountTakerBroker extends string = string, TAccountMakerBroker extends string = string, TAccountRentDestination extends string = string, TAccountTokenProgram extends string = string, TAccountAssociatedTokenProgram extends string = string, TAccountMarketplaceProgram extends string = string, TAccountSystemProgram extends string = string, TAccountMetadata extends string = string, TAccountEdition extends string = string, TAccountBuyerTokenRecord extends string = string, TAccountListTokenRecord extends string = string, TAccountAuthorizationRules extends string = string, TAccountAuthorizationRulesProgram extends string = string, TAccountTokenMetadataProgram extends string = string, TAccountSysvarInstructions extends string = string, TAccountCosigner extends string = string> = {
    feeVault?: Address<TAccountFeeVault>;
    buyer?: Address<TAccountBuyer>;
    buyerTa?: Address<TAccountBuyerTa>;
    listTa?: Address<TAccountListTa>;
    listState?: Address<TAccountListState>;
    mint: Address<TAccountMint>;
    owner: Address<TAccountOwner>;
    payer: TransactionSigner<TAccountPayer>;
    takerBroker?: Address<TAccountTakerBroker>;
    makerBroker?: Address<TAccountMakerBroker>;
    rentDestination?: Address<TAccountRentDestination>;
    tokenProgram?: Address<TAccountTokenProgram>;
    associatedTokenProgram?: Address<TAccountAssociatedTokenProgram>;
    marketplaceProgram?: Address<TAccountMarketplaceProgram>;
    systemProgram?: Address<TAccountSystemProgram>;
    metadata?: Address<TAccountMetadata>;
    edition?: Address<TAccountEdition>;
    buyerTokenRecord?: Address<TAccountBuyerTokenRecord>;
    listTokenRecord?: Address<TAccountListTokenRecord>;
    authorizationRules?: Address<TAccountAuthorizationRules>;
    authorizationRulesProgram?: Address<TAccountAuthorizationRulesProgram>;
    tokenMetadataProgram?: Address<TAccountTokenMetadataProgram>;
    sysvarInstructions?: Address<TAccountSysvarInstructions>;
    cosigner?: TransactionSigner<TAccountCosigner>;
    maxAmount: BuyLegacyInstructionDataArgs['maxAmount'];
    optionalRoyaltyPct?: BuyLegacyInstructionDataArgs['optionalRoyaltyPct'];
    authorizationData?: BuyLegacyInstructionDataArgs['authorizationData'];
    tokenStandard?: BuyLegacyInstructionExtraArgs['tokenStandard'];
    creators?: Array<Address>;
};
export declare function getBuyLegacyInstructionAsync<TAccountFeeVault extends string, TAccountBuyer extends string, TAccountBuyerTa extends string, TAccountListTa extends string, TAccountListState extends string, TAccountMint extends string, TAccountOwner extends string, TAccountPayer extends string, TAccountTakerBroker extends string, TAccountMakerBroker extends string, TAccountRentDestination extends string, TAccountTokenProgram extends string, TAccountAssociatedTokenProgram extends string, TAccountMarketplaceProgram extends string, TAccountSystemProgram extends string, TAccountMetadata extends string, TAccountEdition extends string, TAccountBuyerTokenRecord extends string, TAccountListTokenRecord extends string, TAccountAuthorizationRules extends string, TAccountAuthorizationRulesProgram extends string, TAccountTokenMetadataProgram extends string, TAccountSysvarInstructions extends string, TAccountCosigner extends string>(input: BuyLegacyAsyncInput<TAccountFeeVault, TAccountBuyer, TAccountBuyerTa, TAccountListTa, TAccountListState, TAccountMint, TAccountOwner, TAccountPayer, TAccountTakerBroker, TAccountMakerBroker, TAccountRentDestination, TAccountTokenProgram, TAccountAssociatedTokenProgram, TAccountMarketplaceProgram, TAccountSystemProgram, TAccountMetadata, TAccountEdition, TAccountBuyerTokenRecord, TAccountListTokenRecord, TAccountAuthorizationRules, TAccountAuthorizationRulesProgram, TAccountTokenMetadataProgram, TAccountSysvarInstructions, TAccountCosigner>): Promise<BuyLegacyInstruction<typeof TENSOR_MARKETPLACE_PROGRAM_ADDRESS, TAccountFeeVault, TAccountBuyer, TAccountBuyerTa, TAccountListTa, TAccountListState, TAccountMint, TAccountOwner, TAccountPayer, TAccountTakerBroker, TAccountMakerBroker, TAccountRentDestination, TAccountTokenProgram, TAccountAssociatedTokenProgram, TAccountMarketplaceProgram, TAccountSystemProgram, TAccountMetadata, TAccountEdition, TAccountBuyerTokenRecord, TAccountListTokenRecord, TAccountAuthorizationRules, TAccountAuthorizationRulesProgram, TAccountTokenMetadataProgram, TAccountSysvarInstructions, TAccountCosigner>>;
export type BuyLegacyInput<TAccountFeeVault extends string = string, TAccountBuyer extends string = string, TAccountBuyerTa extends string = string, TAccountListTa extends string = string, TAccountListState extends string = string, TAccountMint extends string = string, TAccountOwner extends string = string, TAccountPayer extends string = string, TAccountTakerBroker extends string = string, TAccountMakerBroker extends string = string, TAccountRentDestination extends string = string, TAccountTokenProgram extends string = string, TAccountAssociatedTokenProgram extends string = string, TAccountMarketplaceProgram extends string = string, TAccountSystemProgram extends string = string, TAccountMetadata extends string = string, TAccountEdition extends string = string, TAccountBuyerTokenRecord extends string = string, TAccountListTokenRecord extends string = string, TAccountAuthorizationRules extends string = string, TAccountAuthorizationRulesProgram extends string = string, TAccountTokenMetadataProgram extends string = string, TAccountSysvarInstructions extends string = string, TAccountCosigner extends string = string> = {
    feeVault: Address<TAccountFeeVault>;
    buyer?: Address<TAccountBuyer>;
    buyerTa: Address<TAccountBuyerTa>;
    listTa: Address<TAccountListTa>;
    listState: Address<TAccountListState>;
    mint: Address<TAccountMint>;
    owner: Address<TAccountOwner>;
    payer: TransactionSigner<TAccountPayer>;
    takerBroker?: Address<TAccountTakerBroker>;
    makerBroker?: Address<TAccountMakerBroker>;
    rentDestination?: Address<TAccountRentDestination>;
    tokenProgram?: Address<TAccountTokenProgram>;
    associatedTokenProgram?: Address<TAccountAssociatedTokenProgram>;
    marketplaceProgram?: Address<TAccountMarketplaceProgram>;
    systemProgram?: Address<TAccountSystemProgram>;
    metadata: Address<TAccountMetadata>;
    edition: Address<TAccountEdition>;
    buyerTokenRecord?: Address<TAccountBuyerTokenRecord>;
    listTokenRecord?: Address<TAccountListTokenRecord>;
    authorizationRules?: Address<TAccountAuthorizationRules>;
    authorizationRulesProgram?: Address<TAccountAuthorizationRulesProgram>;
    tokenMetadataProgram?: Address<TAccountTokenMetadataProgram>;
    sysvarInstructions?: Address<TAccountSysvarInstructions>;
    cosigner?: TransactionSigner<TAccountCosigner>;
    maxAmount: BuyLegacyInstructionDataArgs['maxAmount'];
    optionalRoyaltyPct?: BuyLegacyInstructionDataArgs['optionalRoyaltyPct'];
    authorizationData?: BuyLegacyInstructionDataArgs['authorizationData'];
    tokenStandard?: BuyLegacyInstructionExtraArgs['tokenStandard'];
    creators?: Array<Address>;
};
export declare function getBuyLegacyInstruction<TAccountFeeVault extends string, TAccountBuyer extends string, TAccountBuyerTa extends string, TAccountListTa extends string, TAccountListState extends string, TAccountMint extends string, TAccountOwner extends string, TAccountPayer extends string, TAccountTakerBroker extends string, TAccountMakerBroker extends string, TAccountRentDestination extends string, TAccountTokenProgram extends string, TAccountAssociatedTokenProgram extends string, TAccountMarketplaceProgram extends string, TAccountSystemProgram extends string, TAccountMetadata extends string, TAccountEdition extends string, TAccountBuyerTokenRecord extends string, TAccountListTokenRecord extends string, TAccountAuthorizationRules extends string, TAccountAuthorizationRulesProgram extends string, TAccountTokenMetadataProgram extends string, TAccountSysvarInstructions extends string, TAccountCosigner extends string>(input: BuyLegacyInput<TAccountFeeVault, TAccountBuyer, TAccountBuyerTa, TAccountListTa, TAccountListState, TAccountMint, TAccountOwner, TAccountPayer, TAccountTakerBroker, TAccountMakerBroker, TAccountRentDestination, TAccountTokenProgram, TAccountAssociatedTokenProgram, TAccountMarketplaceProgram, TAccountSystemProgram, TAccountMetadata, TAccountEdition, TAccountBuyerTokenRecord, TAccountListTokenRecord, TAccountAuthorizationRules, TAccountAuthorizationRulesProgram, TAccountTokenMetadataProgram, TAccountSysvarInstructions, TAccountCosigner>): BuyLegacyInstruction<typeof TENSOR_MARKETPLACE_PROGRAM_ADDRESS, TAccountFeeVault, TAccountBuyer, TAccountBuyerTa, TAccountListTa, TAccountListState, TAccountMint, TAccountOwner, TAccountPayer, TAccountTakerBroker, TAccountMakerBroker, TAccountRentDestination, TAccountTokenProgram, TAccountAssociatedTokenProgram, TAccountMarketplaceProgram, TAccountSystemProgram, TAccountMetadata, TAccountEdition, TAccountBuyerTokenRecord, TAccountListTokenRecord, TAccountAuthorizationRules, TAccountAuthorizationRulesProgram, TAccountTokenMetadataProgram, TAccountSysvarInstructions, TAccountCosigner>;
export type ParsedBuyLegacyInstruction<TProgram extends string = typeof TENSOR_MARKETPLACE_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        feeVault: TAccountMetas[0];
        buyer: TAccountMetas[1];
        buyerTa: TAccountMetas[2];
        listTa: TAccountMetas[3];
        listState: TAccountMetas[4];
        mint: TAccountMetas[5];
        owner: TAccountMetas[6];
        payer: TAccountMetas[7];
        takerBroker?: TAccountMetas[8] | undefined;
        makerBroker?: TAccountMetas[9] | undefined;
        rentDestination: TAccountMetas[10];
        tokenProgram: TAccountMetas[11];
        associatedTokenProgram: TAccountMetas[12];
        marketplaceProgram: TAccountMetas[13];
        systemProgram: TAccountMetas[14];
        metadata: TAccountMetas[15];
        edition: TAccountMetas[16];
        buyerTokenRecord?: TAccountMetas[17] | undefined;
        listTokenRecord?: TAccountMetas[18] | undefined;
        authorizationRules?: TAccountMetas[19] | undefined;
        authorizationRulesProgram?: TAccountMetas[20] | undefined;
        tokenMetadataProgram?: TAccountMetas[21] | undefined;
        sysvarInstructions?: TAccountMetas[22] | undefined;
        cosigner?: TAccountMetas[23] | undefined;
    };
    data: BuyLegacyInstructionData;
};
export declare function parseBuyLegacyInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedBuyLegacyInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=buyLegacy.d.ts.map