/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type Option, type OptionOrNullable, type ReadonlyAccount, type ReadonlySignerAccount, type ReadonlyUint8Array, type TransactionSigner, type WritableAccount, type WritableSignerAccount } from '@solana/web3.js';
import { TENSOR_MARKETPLACE_PROGRAM_ADDRESS } from '../programs';
export type ListCompressedInstruction<TProgram extends string = typeof TENSOR_MARKETPLACE_PROGRAM_ADDRESS, TAccountTreeAuthority extends string | IAccountMeta<string> = string, TAccountOwner extends string | IAccountMeta<string> = string, TAccountDelegate extends string | IAccountMeta<string> = string, TAccountMerkleTree extends string | IAccountMeta<string> = string, TAccountLogWrapper extends string | IAccountMeta<string> = 'noopb9bkMVfRPU8AsbpTUg8AQkHtKwMYZiFUjNRtMmV', TAccountCompressionProgram extends string | IAccountMeta<string> = 'cmtDvXumGCrqC1Age74AVPhSRVXJMd8PJS91L8KbNCK', TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TAccountBubblegumProgram extends string | IAccountMeta<string> = 'BGUMAp9Gq7iTEuizy4pqaxsTyUCBK68MDfK752saRPUY', TAccountMarketplaceProgram extends string | IAccountMeta<string> = 'TCMPhJdwDryooaGtiocG1u3xcYbRpiJzb283XfCZsDp', TAccountListState extends string | IAccountMeta<string> = string, TAccountRentPayer extends string | IAccountMeta<string> = string, TAccountCosigner extends string | IAccountMeta<string> = 'TCMPhJdwDryooaGtiocG1u3xcYbRpiJzb283XfCZsDp', TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountTreeAuthority extends string ? ReadonlyAccount<TAccountTreeAuthority> : TAccountTreeAuthority,
    TAccountOwner extends string ? ReadonlyAccount<TAccountOwner> : TAccountOwner,
    TAccountDelegate extends string ? ReadonlyAccount<TAccountDelegate> : TAccountDelegate,
    TAccountMerkleTree extends string ? WritableAccount<TAccountMerkleTree> : TAccountMerkleTree,
    TAccountLogWrapper extends string ? ReadonlyAccount<TAccountLogWrapper> : TAccountLogWrapper,
    TAccountCompressionProgram extends string ? ReadonlyAccount<TAccountCompressionProgram> : TAccountCompressionProgram,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    TAccountBubblegumProgram extends string ? ReadonlyAccount<TAccountBubblegumProgram> : TAccountBubblegumProgram,
    TAccountMarketplaceProgram extends string ? ReadonlyAccount<TAccountMarketplaceProgram> : TAccountMarketplaceProgram,
    TAccountListState extends string ? WritableAccount<TAccountListState> : TAccountListState,
    TAccountRentPayer extends string ? WritableSignerAccount<TAccountRentPayer> & IAccountSignerMeta<TAccountRentPayer> : TAccountRentPayer,
    TAccountCosigner extends string ? ReadonlySignerAccount<TAccountCosigner> & IAccountSignerMeta<TAccountCosigner> : TAccountCosigner,
    ...TRemainingAccounts
]>;
export type ListCompressedInstructionData = {
    discriminator: ReadonlyUint8Array;
    nonce: bigint;
    index: number;
    root: ReadonlyUint8Array;
    dataHash: ReadonlyUint8Array;
    creatorHash: ReadonlyUint8Array;
    amount: bigint;
    expireInSec: Option<bigint>;
    currency: Option<Address>;
    privateTaker: Option<Address>;
    makerBroker: Option<Address>;
};
export type ListCompressedInstructionDataArgs = {
    nonce: number | bigint;
    index: number;
    root: ReadonlyUint8Array;
    dataHash: ReadonlyUint8Array;
    creatorHash: ReadonlyUint8Array;
    amount: number | bigint;
    expireInSec?: OptionOrNullable<number | bigint>;
    currency?: OptionOrNullable<Address>;
    privateTaker?: OptionOrNullable<Address>;
    makerBroker?: OptionOrNullable<Address>;
};
export declare function getListCompressedInstructionDataEncoder(): Encoder<ListCompressedInstructionDataArgs>;
export declare function getListCompressedInstructionDataDecoder(): Decoder<ListCompressedInstructionData>;
export declare function getListCompressedInstructionDataCodec(): Codec<ListCompressedInstructionDataArgs, ListCompressedInstructionData>;
export type ListCompressedInstructionExtraArgs = {
    /** proof path, can be shortened if canopyDepth of merkle tree is also specified */
    proof?: Array<Address>;
    /** canopy depth of merkle tree, reduces proofPath length if specified */
    canopyDepth?: number;
};
export type ListCompressedAsyncInput<TAccountTreeAuthority extends string = string, TAccountOwner extends string = string, TAccountDelegate extends string = string, TAccountMerkleTree extends string = string, TAccountLogWrapper extends string = string, TAccountCompressionProgram extends string = string, TAccountSystemProgram extends string = string, TAccountBubblegumProgram extends string = string, TAccountMarketplaceProgram extends string = string, TAccountListState extends string = string, TAccountRentPayer extends string = string, TAccountCosigner extends string = string> = {
    treeAuthority?: Address<TAccountTreeAuthority>;
    owner: Address<TAccountOwner> | TransactionSigner<TAccountOwner>;
    delegate?: Address<TAccountDelegate> | TransactionSigner<TAccountDelegate>;
    merkleTree: Address<TAccountMerkleTree>;
    logWrapper?: Address<TAccountLogWrapper>;
    compressionProgram?: Address<TAccountCompressionProgram>;
    systemProgram?: Address<TAccountSystemProgram>;
    bubblegumProgram?: Address<TAccountBubblegumProgram>;
    marketplaceProgram?: Address<TAccountMarketplaceProgram>;
    listState: Address<TAccountListState>;
    rentPayer?: TransactionSigner<TAccountRentPayer>;
    cosigner?: TransactionSigner<TAccountCosigner>;
    nonce?: ListCompressedInstructionDataArgs['nonce'];
    index: ListCompressedInstructionDataArgs['index'];
    root: ListCompressedInstructionDataArgs['root'];
    dataHash: ListCompressedInstructionDataArgs['dataHash'];
    creatorHash: ListCompressedInstructionDataArgs['creatorHash'];
    amount: ListCompressedInstructionDataArgs['amount'];
    expireInSec?: ListCompressedInstructionDataArgs['expireInSec'];
    currency?: ListCompressedInstructionDataArgs['currency'];
    privateTaker?: ListCompressedInstructionDataArgs['privateTaker'];
    makerBroker?: ListCompressedInstructionDataArgs['makerBroker'];
    proof?: ListCompressedInstructionExtraArgs['proof'];
    canopyDepth?: ListCompressedInstructionExtraArgs['canopyDepth'];
};
export declare function getListCompressedInstructionAsync<TAccountTreeAuthority extends string, TAccountOwner extends string, TAccountDelegate extends string, TAccountMerkleTree extends string, TAccountLogWrapper extends string, TAccountCompressionProgram extends string, TAccountSystemProgram extends string, TAccountBubblegumProgram extends string, TAccountMarketplaceProgram extends string, TAccountListState extends string, TAccountRentPayer extends string, TAccountCosigner extends string>(input: ListCompressedAsyncInput<TAccountTreeAuthority, TAccountOwner, TAccountDelegate, TAccountMerkleTree, TAccountLogWrapper, TAccountCompressionProgram, TAccountSystemProgram, TAccountBubblegumProgram, TAccountMarketplaceProgram, TAccountListState, TAccountRentPayer, TAccountCosigner>): Promise<ListCompressedInstruction<typeof TENSOR_MARKETPLACE_PROGRAM_ADDRESS, TAccountTreeAuthority, (typeof input)['owner'] extends TransactionSigner<TAccountOwner> ? ReadonlySignerAccount<TAccountOwner> & IAccountSignerMeta<TAccountOwner> : TAccountOwner, (typeof input)['delegate'] extends TransactionSigner<TAccountDelegate> ? ReadonlySignerAccount<TAccountDelegate> & IAccountSignerMeta<TAccountDelegate> : TAccountDelegate, TAccountMerkleTree, TAccountLogWrapper, TAccountCompressionProgram, TAccountSystemProgram, TAccountBubblegumProgram, TAccountMarketplaceProgram, TAccountListState, TAccountRentPayer, TAccountCosigner>>;
export type ListCompressedInput<TAccountTreeAuthority extends string = string, TAccountOwner extends string = string, TAccountDelegate extends string = string, TAccountMerkleTree extends string = string, TAccountLogWrapper extends string = string, TAccountCompressionProgram extends string = string, TAccountSystemProgram extends string = string, TAccountBubblegumProgram extends string = string, TAccountMarketplaceProgram extends string = string, TAccountListState extends string = string, TAccountRentPayer extends string = string, TAccountCosigner extends string = string> = {
    treeAuthority: Address<TAccountTreeAuthority>;
    owner: Address<TAccountOwner> | TransactionSigner<TAccountOwner>;
    delegate?: Address<TAccountDelegate> | TransactionSigner<TAccountDelegate>;
    merkleTree: Address<TAccountMerkleTree>;
    logWrapper?: Address<TAccountLogWrapper>;
    compressionProgram?: Address<TAccountCompressionProgram>;
    systemProgram?: Address<TAccountSystemProgram>;
    bubblegumProgram?: Address<TAccountBubblegumProgram>;
    marketplaceProgram?: Address<TAccountMarketplaceProgram>;
    listState: Address<TAccountListState>;
    rentPayer?: TransactionSigner<TAccountRentPayer>;
    cosigner?: TransactionSigner<TAccountCosigner>;
    nonce?: ListCompressedInstructionDataArgs['nonce'];
    index: ListCompressedInstructionDataArgs['index'];
    root: ListCompressedInstructionDataArgs['root'];
    dataHash: ListCompressedInstructionDataArgs['dataHash'];
    creatorHash: ListCompressedInstructionDataArgs['creatorHash'];
    amount: ListCompressedInstructionDataArgs['amount'];
    expireInSec?: ListCompressedInstructionDataArgs['expireInSec'];
    currency?: ListCompressedInstructionDataArgs['currency'];
    privateTaker?: ListCompressedInstructionDataArgs['privateTaker'];
    makerBroker?: ListCompressedInstructionDataArgs['makerBroker'];
    proof?: ListCompressedInstructionExtraArgs['proof'];
    canopyDepth?: ListCompressedInstructionExtraArgs['canopyDepth'];
};
export declare function getListCompressedInstruction<TAccountTreeAuthority extends string, TAccountOwner extends string, TAccountDelegate extends string, TAccountMerkleTree extends string, TAccountLogWrapper extends string, TAccountCompressionProgram extends string, TAccountSystemProgram extends string, TAccountBubblegumProgram extends string, TAccountMarketplaceProgram extends string, TAccountListState extends string, TAccountRentPayer extends string, TAccountCosigner extends string>(input: ListCompressedInput<TAccountTreeAuthority, TAccountOwner, TAccountDelegate, TAccountMerkleTree, TAccountLogWrapper, TAccountCompressionProgram, TAccountSystemProgram, TAccountBubblegumProgram, TAccountMarketplaceProgram, TAccountListState, TAccountRentPayer, TAccountCosigner>): ListCompressedInstruction<typeof TENSOR_MARKETPLACE_PROGRAM_ADDRESS, TAccountTreeAuthority, (typeof input)['owner'] extends TransactionSigner<TAccountOwner> ? ReadonlySignerAccount<TAccountOwner> & IAccountSignerMeta<TAccountOwner> : TAccountOwner, (typeof input)['delegate'] extends TransactionSigner<TAccountDelegate> ? ReadonlySignerAccount<TAccountDelegate> & IAccountSignerMeta<TAccountDelegate> : TAccountDelegate, TAccountMerkleTree, TAccountLogWrapper, TAccountCompressionProgram, TAccountSystemProgram, TAccountBubblegumProgram, TAccountMarketplaceProgram, TAccountListState, TAccountRentPayer, TAccountCosigner>;
export type ParsedListCompressedInstruction<TProgram extends string = typeof TENSOR_MARKETPLACE_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        treeAuthority: TAccountMetas[0];
        owner: TAccountMetas[1];
        delegate: TAccountMetas[2];
        merkleTree: TAccountMetas[3];
        logWrapper: TAccountMetas[4];
        compressionProgram: TAccountMetas[5];
        systemProgram: TAccountMetas[6];
        bubblegumProgram: TAccountMetas[7];
        marketplaceProgram: TAccountMetas[8];
        listState: TAccountMetas[9];
        rentPayer: TAccountMetas[10];
        cosigner?: TAccountMetas[11] | undefined;
    };
    data: ListCompressedInstructionData;
};
export declare function parseListCompressedInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedListCompressedInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=listCompressed.d.ts.map