/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/kinobi-so/kinobi
 */
import { type Address, type Codec, type Decoder, type Encoder, type IAccountMeta, type IAccountSignerMeta, type IInstruction, type IInstructionWithAccounts, type IInstructionWithData, type Option, type OptionOrNullable, type ReadonlyAccount, type ReadonlySignerAccount, type ReadonlyUint8Array, type TransactionSigner, type WritableAccount, type WritableSignerAccount } from '@solana/web3.js';
import { TENSOR_MARKETPLACE_PROGRAM_ADDRESS } from '../programs';
export type ListCoreInstruction<TProgram extends string = typeof TENSOR_MARKETPLACE_PROGRAM_ADDRESS, TAccountAsset extends string | IAccountMeta<string> = string, TAccountCollection extends string | IAccountMeta<string> = string, TAccountListState extends string | IAccountMeta<string> = string, TAccountOwner extends string | IAccountMeta<string> = string, TAccountMplCoreProgram extends string | IAccountMeta<string> = 'CoREENxT6tW1HoK8ypY1SxRMZTcVPm7R94rH4PZNhX7d', TAccountMarketplaceProgram extends string | IAccountMeta<string> = 'TCMPhJdwDryooaGtiocG1u3xcYbRpiJzb283XfCZsDp', TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TAccountPayer extends string | IAccountMeta<string> = string, TAccountCosigner extends string | IAccountMeta<string> = string, TRemainingAccounts extends readonly IAccountMeta<string>[] = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountAsset extends string ? WritableAccount<TAccountAsset> : TAccountAsset,
    TAccountCollection extends string ? ReadonlyAccount<TAccountCollection> : TAccountCollection,
    TAccountListState extends string ? WritableAccount<TAccountListState> : TAccountListState,
    TAccountOwner extends string ? ReadonlySignerAccount<TAccountOwner> & IAccountSignerMeta<TAccountOwner> : TAccountOwner,
    TAccountMplCoreProgram extends string ? ReadonlyAccount<TAccountMplCoreProgram> : TAccountMplCoreProgram,
    TAccountMarketplaceProgram extends string ? ReadonlyAccount<TAccountMarketplaceProgram> : TAccountMarketplaceProgram,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    TAccountPayer extends string ? WritableSignerAccount<TAccountPayer> & IAccountSignerMeta<TAccountPayer> : TAccountPayer,
    TAccountCosigner extends string ? ReadonlySignerAccount<TAccountCosigner> & IAccountSignerMeta<TAccountCosigner> : TAccountCosigner,
    ...TRemainingAccounts
]>;
export type ListCoreInstructionData = {
    discriminator: ReadonlyUint8Array;
    amount: bigint;
    expireInSec: Option<bigint>;
    currency: Option<Address>;
    privateTaker: Option<Address>;
    makerBroker: Option<Address>;
};
export type ListCoreInstructionDataArgs = {
    amount: number | bigint;
    expireInSec?: OptionOrNullable<number | bigint>;
    currency?: OptionOrNullable<Address>;
    privateTaker?: OptionOrNullable<Address>;
    makerBroker?: OptionOrNullable<Address>;
};
export declare function getListCoreInstructionDataEncoder(): Encoder<ListCoreInstructionDataArgs>;
export declare function getListCoreInstructionDataDecoder(): Decoder<ListCoreInstructionData>;
export declare function getListCoreInstructionDataCodec(): Codec<ListCoreInstructionDataArgs, ListCoreInstructionData>;
export type ListCoreInput<TAccountAsset extends string = string, TAccountCollection extends string = string, TAccountListState extends string = string, TAccountOwner extends string = string, TAccountMplCoreProgram extends string = string, TAccountMarketplaceProgram extends string = string, TAccountSystemProgram extends string = string, TAccountPayer extends string = string, TAccountCosigner extends string = string> = {
    asset: Address<TAccountAsset>;
    collection?: Address<TAccountCollection>;
    listState: Address<TAccountListState>;
    owner: TransactionSigner<TAccountOwner>;
    mplCoreProgram?: Address<TAccountMplCoreProgram>;
    marketplaceProgram?: Address<TAccountMarketplaceProgram>;
    systemProgram?: Address<TAccountSystemProgram>;
    payer: TransactionSigner<TAccountPayer>;
    cosigner?: TransactionSigner<TAccountCosigner>;
    amount: ListCoreInstructionDataArgs['amount'];
    expireInSec?: ListCoreInstructionDataArgs['expireInSec'];
    currency?: ListCoreInstructionDataArgs['currency'];
    privateTaker?: ListCoreInstructionDataArgs['privateTaker'];
    makerBroker?: ListCoreInstructionDataArgs['makerBroker'];
};
export declare function getListCoreInstruction<TAccountAsset extends string, TAccountCollection extends string, TAccountListState extends string, TAccountOwner extends string, TAccountMplCoreProgram extends string, TAccountMarketplaceProgram extends string, TAccountSystemProgram extends string, TAccountPayer extends string, TAccountCosigner extends string>(input: ListCoreInput<TAccountAsset, TAccountCollection, TAccountListState, TAccountOwner, TAccountMplCoreProgram, TAccountMarketplaceProgram, TAccountSystemProgram, TAccountPayer, TAccountCosigner>): ListCoreInstruction<typeof TENSOR_MARKETPLACE_PROGRAM_ADDRESS, TAccountAsset, TAccountCollection, TAccountListState, TAccountOwner, TAccountMplCoreProgram, TAccountMarketplaceProgram, TAccountSystemProgram, TAccountPayer, TAccountCosigner>;
export type ParsedListCoreInstruction<TProgram extends string = typeof TENSOR_MARKETPLACE_PROGRAM_ADDRESS, TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        asset: TAccountMetas[0];
        collection?: TAccountMetas[1] | undefined;
        listState: TAccountMetas[2];
        owner: TAccountMetas[3];
        mplCoreProgram: TAccountMetas[4];
        marketplaceProgram: TAccountMetas[5];
        systemProgram: TAccountMetas[6];
        payer: TAccountMetas[7];
        cosigner?: TAccountMetas[8] | undefined;
    };
    data: ListCoreInstructionData;
};
export declare function parseListCoreInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedListCoreInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=listCore.d.ts.map