import { Address, IAccountMeta, ProgramDerivedAddress, ProgramDerivedAddressBump, TransactionSigner } from '@solana/web3.js';
import { Target } from '../generated';
import { ResolvedAccount } from '../generated/shared';
export declare const resolveBidIdOnCreate: ({ args, }: {
    programAddress: Address;
    accounts: Record<string, ResolvedAccount>;
    args: {
        target?: Target;
        targetId?: Address;
    };
}) => Promise<Address>;
export declare const resolveFeeVaultPdaFromListState: ({ accounts, }: {
    accounts: Record<string, ResolvedAccount>;
}) => Promise<Partial<{
    value: ProgramDerivedAddress | null;
}>>;
export declare const resolveFeeVaultPdaFromBidState: ({ accounts, }: {
    accounts: Record<string, ResolvedAccount>;
}) => Promise<Partial<{
    value: ProgramDerivedAddress | null;
}>>;
export declare const resolveTreeAuthorityPda: ({ accounts, }: {
    accounts: Record<string, ResolvedAccount>;
}) => Promise<Partial<{
    value: ProgramDerivedAddress | null;
}>>;
type ArgsWithOptionalCreatorsField = {
    creators?: (readonly [Address, number])[] | undefined;
    [key: string]: unknown;
};
type ArgsWithOptionalProofAndCanopyDepth = {
    proof?: Address[] | undefined;
    canopyDepth?: number | undefined;
    [key: string]: unknown;
};
export declare const resolveCreatorPath: ({ args, }: {
    args: ArgsWithOptionalCreatorsField;
}) => IAccountMeta[];
export declare const resolveProofPath: ({ args, }: {
    args: ArgsWithOptionalProofAndCanopyDepth;
}) => IAccountMeta[];
export declare const resolveRemainingSignerWithOwnerOrDelegate: ({ accounts, }: {
    accounts: Record<string, ResolvedAccount>;
}) => {
    value: Address | readonly [Address<string>, ProgramDerivedAddressBump] | TransactionSigner | null;
};
export declare const resolveRemainingSignerWithSellerOrDelegate: ({ accounts, }: {
    accounts: Record<string, ResolvedAccount>;
}) => {
    value: Address | readonly [Address<string>, ProgramDerivedAddressBump] | TransactionSigner | null;
};
export declare const resolveBidTa: ({ accounts, }: {
    accounts: Record<string, ResolvedAccount>;
}) => Promise<Partial<{
    value: ProgramDerivedAddress | null;
}>>;
export {};
//# sourceMappingURL=resolvers.d.ts.map